#ifndef __DATASET_H__
#define __DATASET_H__

#include <stdio.h>


typedef struct
{
    double ** data;
    size_t n;			/* records in vector */
    size_t alloc_size;		/* allocated records */
    size_t n_items;		/* number of items */
} dataset;

dataset *
dataset_new(void);

void
dataset_free(dataset * d, int free_records);

int
dataset_append_record(dataset * d, double * record);

dataset *
dataset_clone(dataset * d, int clone_records);

#define TIES_MIN 0
#define TIES_MAX 1
#define TIES_AVG 2

void
convert_to_ranks(dataset * d, int mode);

#endif
