#ifndef __HTABHLE_H__
#define __HTABHLE_H__


#include <stdlib.h>

typedef struct
{
    void * key;
    void * value;
} entry;

typedef struct
{
    size_t n;			/* elems in the table */
    size_t alloc_size;		/* allocated size */
    size_t (* hashfunc)(void *); /* hash func */
    int (* cmpfunc)(void *, void *); /* cmp func */
    entry * entries;
} htable;


htable *
htable_new(size_t (* hashfunc)(void *), int (* cmpfunc)(void *, void *));

void
htable_free(htable * h, int free_keys, int free_values);

void *
htable_get(htable * h, void * key);

/* if key already present replaces the value but does not free old
   value */
void
htable_put(htable * h, void * key, void * value);

#endif
