#ifndef __KDTREE_H__
#define __KDTREE_H__

#include <stdlib.h>

#include "dataset.h"

typedef struct
{
    double ** data;		/* records in KDtree */
    size_t n;			/* number of records in KDtree */
    size_t n_dim;		/* number of dimensions */
    size_t * dims;		/* dimaensions */
} KDtree;

/* initializes KDtree.  Only reference to data is kept.  Data is
   reordered in the process. The tree is kept as a list of records. */
void KDtree_init(KDtree * kdtree, dataset * d, size_t n_items, size_t * dims);

size_t
KDtree_count(KDtree * kdtree, const double * bounds);
#endif
