#ifndef __RANGETREE_H__
#define __RANGETREE_H__

#include <stdlib.h>

#include "dataset.h"

typedef struct
{
    double * record;		/* pointer to database record */
    double value;		/* indexed value */
} index_entry;


typedef struct Range_tree
{
    size_t counter;
    struct Range_tree * list;
    size_t listlen;
    double value;
    size_t dim;
} range_tree;

range_tree *
range_tree_new(double value);

void
range_tree_free(range_tree * r);

void range_tree_add_dim(range_tree * r, size_t a, index_entry * ind, size_t indlen);

size_t
range_tree_get_count(range_tree * r, double * bounds, size_t lenbounds);

index_entry **
range_tree_create_indices(dataset * d);

void
range_tree_free_indices(index_entry ** indices, size_t n_indices);

#endif
